<template>
  <div class="ac-dual-list d-flex justify-content-between">
    <ac-collection
      ref="ac_collection_left"
      v-bind="collection_options"
      @success="on_succes_load"
      class="ac-dual-list__item"
    >
      <template #header>
        <header class="border p-2 d-flex align-items-center">
          <b-checkbox
            v-model="all_checkbox.left"
            @change="on_checkbox_change($event, 'left')"
          />

          <b-input
            v-model="input.left"
            placeholder="Filter"
            size="sm"
          />

          <b-button
            v-show="collection_options.sort_key"
            size="sm"
            variant="outline-secondary"
            class="ml-1"
          >
            Sort
          </b-button>

          <ac-material-drowpdown
            v-show="dropdown_options"
            v-bind="dropdown_options"
            class="ml-1"
            @item_click="$emit('dropdown_click', $event, 'left')"
          />
        </header>
      </template>

      <template #body="{ data }">
        <div class="border-left border-right p-2 h-100 ac-dual-list__body">
          <p
            v-show="!filtered_left.length"
            class="text-center"
          >
            No item to show
          </p>

          <b-form-checkbox-group
            v-model="selected.left"
            stacked
          >
            <b-form-checkbox
              v-for="item in filtered_left"
              :key="item.value"
              :value="item.value"
            >
              {{ item.label }}
            </b-form-checkbox>
          </b-form-checkbox-group>
        </div>
      </template>

      <template #footer>
        <footer class="border p-2">
          {{ selected.left.length }}
          of
          {{ values.left.length }}
          items selected
        </footer>
      </template>
    </ac-collection>

    <div
      class="d-flex p-2 flex-column align-items-center justify-content-center"
    >
      <b-button
        @click="move_checkboxes('left', 'right')"
      >
        &gt;
      </b-button>

      <b-button
        class="mt-4"
        @click="move_checkboxes('right', 'left')"
      >
        &lt;
      </b-button>
    </div>


    <div class="d-flex flex-column ac-dual-list__item">
      <div class="border p-2 d-flex align-items-center">
        <b-checkbox
          v-model="all_checkbox.right"
          @change="on_checkbox_change($event, 'right')"
        />

        <b-input
          v-model="input.right"
          placeholder="Filter"
          size="sm"
        />

        <b-button
          v-show="collection_options.sort_key"
          size="sm"
          variant="outline-secondary"
          class="ml-1"
        >
          Sort
        </b-button>

        <ac-material-drowpdown
          v-show="dropdown_options"
          v-bind="dropdown_options"
          class="ml-1"
          @item_click="$emit('dropdown_click', $event, 'right')"
        />
      </div>

      <div class="border-left border-right p-2 flex-auto ac-dual-list__body">
        <p
          v-show="!filtered_right.length"
          class="text-center"
        >
          No item to show
        </p>

        <b-form-checkbox-group
          v-model="selected.right"
          stacked
        >
          <b-form-checkbox
            v-for="item in filtered_right"
            :key="item.value"
            :value="item.value"
          >
            {{ item.label }}
          </b-form-checkbox>
        </b-form-checkbox-group>
      </div>

      <div class="border p-2">
        {{ selected.right.length }}
        of
        {{ values.right.length }}
        items selected
      </div>
    </div>
  </div>
</template>

<script>
import acCollection from '../ac-collection.vue'
import acMaterialDrowpdown from '../ac-material-dropdown.vue'

/**
 * ac dual list component
 * @requires VueBootstrap
 * @requires ac-collection.vue
 * @requires ac-material-dropdown.vue
 * @fires change - array of changed values, direction
 * @fires dropdown_click - click option, direction
 */

export default {
  name: 'ac-dual-list',

  components: {
    acCollection,
    acMaterialDrowpdown,
  },

  props: {
    /**
     * @param {array} options - list of options
     */
    options: {
      type: Array,
      required: false,
      default: () => ([]),
    },

    /**
     * @param {Object} collection_options - props for ac_collection
     */
    collection_options: {
      type: Object,
      required: true,
    },

    /**
     * @param {Object} dropdown_options - props for ac_dropdown
     */
    dropdown_options: {
      type: Object,
      required: false,
    },

    /**
     * @param {Array} value - v-model value
     */
    value: {
      type: Array,
      required: false,
      default: () => ([]),
    },
  },

  data() {
    return {
      selected: {
        left: [],
        right: [],
      },
      all_checkbox: {
        left: false,
        right: false,
      },
      values: {
        left: [],
        right: [],
      },
      input: {
        left: '',
        right: '',
      },
    }
  },

  computed: {
    filtered_left() {
      this.remove_selected('left')
      this.disable_all_checkbox('left')
      if (!this.input.left.length) return this.values.left
      return this.values.left.filter(el => el.label.indexOf(this.input.left) > -1)
    },

    filtered_right() {
      this.remove_selected('right')
      this.disable_all_checkbox('right')
      if (!this.input.right.length) return this.values.right
      return this.values.right.filter(el => el.label.indexOf(this.input.right) > -1)
    },
  },

  created() {
    this.values.right = this.value
  },

  mounted() {
    if (this.options && this.options.length) {
      this.$refs.ac_collection_left.set_data(this.options)
      this.values.left = this.options
    } else if (this.collection_options.url) {
      this.$refs.ac_collection_left.set_ajax()
    }
  },

  methods: {
    /**
     * @function on_succes_load - set new data afer api call
     * @param data - array of options
     */
    on_succes_load(data) {
      this.values.left = [...data]
      this.sort_list('left')
    },

    /**
     * @function move_checkboxes - checked options move handler
     * @param from - from direction
     * @param to - to direction
     * @fires change
     * @fires input - for v-model
     */
    move_checkboxes(from, to) {
      if (!this.selected[from].length) return
      const data = [...this.values[from]]
      const checked = data.filter(el => this.selected[from].indexOf(el.value) > -1)
      const selected = [...checked, ...this.values[to]]
      const rest = data.filter(el => this.selected[from].indexOf(el.value) === -1)
      this.selected[from] = []
      this.values[to] = selected
      this.values[from] = rest
      this.sort_list(to)
      this.disable_all_checkbox(from)
      this.disable_all_checkbox(to)
      this.$emit('change', checked, to)
      this.$emit('input', this.values.right)
    },

    /**
     * @function disable_all_checkbox - remove checked from header checkbox
     * @param type - direction
     */
    disable_all_checkbox(type) {
      this.all_checkbox[type] = false
    },

    /**
     * @function sort_list - sorts list with collection_options.sort_key prop. Default label
     * @param type - direction
     */
    sort_list(type) {
      const key = this.collection_options.sort_key || 'label'
      this.values[type].sort((a, b) => {
        if (a[key] > b[key]) return 1
        if (a[key] < b[key]) return -1
        return 0
      })
    },

    /**
     * @function select_all - mark all options in list as checked
     * @param type - direction
     */
    select_all(type) {
      this.selected[type] = this[`filtered_${type}`].map(el => el.value)
    },

    /**
     * @function remove_selected - mark all options in list as not checked
     * @param type - direction
     */
    remove_selected(type) {
      this.selected[type] = []
    },

    /**
     * @function on_checkbox_change - header checkbox change handler
     * @param val - boolean value of header checkbox
     * @param type - direction
     */
    on_checkbox_change(val, type) {
      if (val) {
        this.select_all(type)
        return
      }

      this.remove_selected(type)
    },
  },
}
</script>

<style scoped>
  .flex-auto {
    flex: auto;
  }

  .ac-dual-list__body {
    max-height: 300px;
    overflow: auto;
  }

  .ac-dual-list__item {
    flex-basis: 47.5%;
  }
</style>
